#include <bits/stdc++.h>
typedef long long ll;
#define rep(i,n) for(int i=0;i<n;i++)
using namespace std;

enum {
	ERR_TLENGTH = 1,
	ERR_TCHAR = 2,
	ERR_TCOINSIDE = 3,
	ERR_LRANGE = 4,
	ERR_BRUNOCORRECT = 5
};

const int MAXL = 130;
int subtask;

void ok(int L) {
	int sc;
	if(subtask!=5){
		fprintf(stderr, "translate:%s\n", "success");
		sc=100;
	}
	else{
		if (130 < L) sc = 0;
		else if (61 < L) sc = 10;
		else if (41 < L) sc = 20;
		else if (34 < L) sc = 25+3*(41-L);
		else if (28 < L) sc = 46+4*(34-L);
		else sc = 70;
		sc+=30;
		fprintf(stderr, "translate:%s\n", (sc == 100) ? "success" : "partial");
	}
	double score = (double)sc / 100.0;
	fprintf(stderr, "Accepted\n");
	fprintf(stdout, "%.2lf\n", score);
}

int main(int argc, char** argv) {
	if (argc < 5) {
		fprintf(stderr, "Usage: %s <out0> <in0> <out1> <in1>\n", argv[0]);
		return 1;
	}
	// fprintf(stderr,"manager\n"); fflush(stderr);


	// open PIPEs
	signal(SIGPIPE, SIG_IGN);
	FILE* out0 = fopen(argv[1], "r");
	FILE*  in0 = fopen(argv[2], "w");
	FILE* out1 = fopen(argv[3], "r");
	FILE*  in1 = fopen(argv[4], "w");

	//definition of error functions
	auto wrong=[&](int num) {
		fprintf(in0, "WA\n");
		fflush(in0);
		fprintf(in1, "WA\n");
		fflush(in1);

		fprintf(stderr, "translate:wrong\n");
		fprintf(stderr, "Wrong Answer [%d]\n", num);
		fprintf(stdout, "%.2lf\n", 0.0);
		exit(0);
	};

	auto check_user_error=[&](FILE* &outfile){
		try {
			int err;
			if (fscanf(outfile, "%d", &err) != 1) throw 0;
			if (err != 0) throw err;
		} catch (int e) {
			wrong(e);
		}
	};

	// read a testcase
	int N;
	string S;
	char buf[500001];
	int seed;
	if (scanf("%d", &N) != 1) {
		fprintf(stderr, "manager failed to read testcase");
		wrong(0);
	}
	if (scanf("%500000s%*[^\n]", buf) != 1) {
		fprintf(stderr, "manager failed to read testcase");
		wrong(0);
	}
	if (scanf("%d", &seed) != 1) {
		fprintf(stderr, "manager failed to read testcase");
		wrong(0);
	}
	if (scanf("%d", &subtask) != 1) {
		fprintf(stderr, "manager failed to read testcase");
		wrong(0);
	}
	S=buf;

	// std::random_device seed_gen;
  std::mt19937 engine(seed);

	// 1.prepare
	char prepare[10];
	fprintf(in0, "Start\n");
	fflush(in0);
	fprintf(in1, "Start\n");
	fflush(in1);
	//4.prepare
	if (fscanf(out0, "%10s%*[^\n]", prepare) != 1) {
		wrong(0);
	}
	if (fscanf(out1, "%10s%*[^\n]", prepare) != 1) {
		wrong(0);
	}

	// 5.write response to user program 0
	fprintf(in0, "Success\n");
	fflush(in0);

	// 8.read error code from user program 0
	check_user_error(out0);

	// 9.write data (N,S) to user program 0
	fprintf(in0, "%d\n", N);
	fflush( in0);
	rep(i,N){
		fprintf(in0, "%c", S[i]);
	}
	fprintf(in0, "\n");
	fflush( in0);


	// 12.read error code from user program 0
	check_user_error(out0);

	// 14.read data (T,L) from user program 0
	string t;
	int l;
	try {
		char ch;
		if(fscanf(out0, "%c",&ch)!=1){
			fprintf(stderr, "manager failed to read LF from user program 0");
			throw 0;
		}
		if (fscanf(out0, "%500000s%*[^\n]", buf) != 1) {
			fprintf(stderr, "manager failed to read data t from user program 0");
			throw 0;
		}
		t=buf;

		if (fscanf(out0, "%d", &l) != 1) {
			fprintf(stderr, "manager failed to read data L from user program 0");
			throw 0;
		}

		// validate for sure (Wrong 1,2,3,4)
		if((int)t.size()!=N) throw (int)ERR_TLENGTH;

		for(auto c:t){
			if(c!='R'&&c!='G'&&c!='B'){
				throw (int)ERR_TCHAR;
			}
		}

		for(int i=0;i<N;i++){
			if(S[i]==t[i]){
				throw (int)ERR_TCOINSIDE;
			}
		}

		if (!(1 <= l && l <= min(N,MAXL))) {
			throw (int)ERR_LRANGE;
		}
	} catch (int e) {
		wrong(e);
	}

	// 15.write response to user program 1
	fprintf(in1, "Success\n");
	fflush( in1);

	int Q=10000;

	// 17.write data (Q,N,l) to user program 1
	fprintf(in1, "%d\n%d\n%d\n", Q,N,l);
	fflush(in1);

	// 20.read error code from user program 1
	check_user_error(out1);
	
	//select A adaptively
	vector<int> A;

	string str="RGB";
	vector<int> Ti;
	rep(i,N){
		rep(x,3)if(str[x]==t[i]){
			Ti.push_back(x);
		}
	}
	const ll mod=1000000009;
	map<ll,vector<ll> > mas;
	rep(i,N-l+1){
		ll has=0;
		rep(j,l)has=(has*3+Ti[i+j])%mod;
		if(mas.count(has)){
			ll x=mas[has].back();
			rep(_,20){
				if(engine()%2==0)A.push_back(i+1);
				else A.push_back(x+1);
			}
		}
		mas[has].push_back(i);
		if((int)A.size()>Q)break;
	}

	//generate A randomly
	rep(i,200){
		A.push_back(i+1);
		A.push_back(N-l+1-i);
	}
	while((int)A.size()<Q){
		A.push_back(1+engine()%(N+1-l));
	}
	while((int)A.size()>Q)A.pop_back();
	for(int i=(int)A.size()-1;i;i--){
		swap(A[i],A[engine()%(i+1)]);
	}

	rep(i,Q){
		if(A[i]<1)A[i]=1;
		if(A[i]>N-l+1)A[i]=N-l+1;
	}

	for (int i = 0; i < Q; i++) {

		// q1.write data (U) to user program 1
		string u=t.substr(A[i]-1,l);
		rep(j,l){
			fprintf(in1,"%c",u[j]);
		}
		fprintf(in1, "\n");
		fflush(in1);

		// q4.read error code from user program 1
		check_user_error(out1);

		// q6.read data (answer) from user program 1
		int answer;
		try {
			if (fscanf(out1, "%d", &answer) != 1) {
				fprintf(stderr, "manager failed to read answer from user program 0 ");
				throw 0;
			}

			// validate for sure (Wrong 5)
			if(A[i]!=answer)throw (int)ERR_BRUNOCORRECT;
		} catch (int e) {
			wrong(e);
		}

		// q7.write response to user program 1
		fprintf(in1, "Success\n");
		fflush( in1);

	}
	// output the score
	ok(l);

	return 0;
}
